#ifndef _MM2_H_
#define _MM2_H_


// Config

#define SW_VERSION_BASE	0x2F

#define CRAPPY_COMPILER // struct byte[0] wird von WinAVR20070525 automatisch mit 0 berschrieben

#define ULTIMATE_BIG_SPEEDCTRL
//#define ULTIMATE_BIG
//#define ULTIMATE
//#define NORMAL
//#define LED_DISP		// Kompletter Wegfall aller Display-/Aufnahmefunktionen
//#define PERFORMANT_PLAYER_DEBUG
//#define OLD_MEGA8



#if defined(ULTIMATE)
	//#define BACKLIGHT		// LCD-Hintergrundbeleuchtung im Men einstellbar
    #define CHANNEL_MUTE	// MIDI-Kanalstummschaltfeature
    #define TRANSPOSE		// Transponierfeature
    #define LYRICS			// Lyricfeature
	//#define MIDI_MONITOR	// MIDI-Monitor verfgbar
    #define MIDI_BLIP		// [neu] Anzeige MIDI-Out-Aktivitt
    #define DIR_SUPPORT		// [neu] Untersttzung zum Browsen von Unterverzeichnissen
	#define LFN_SCROLLING	// [neu] Scrollt lange Dateinamen
		#define LFN_USEBUF	// Playbuf hernehmen
	#define KEY_REPEAT		// Taste gedrckt halten ist wie am PC
    #define KEY_REMAP		// [neu] Tastenbelegung neu
	#define DIREKTWAHL		// Wahl eines Songs per Zifferntasten
	#define USE_ALLCTRLOFF	// Sendet AllControllerOff-Nachricht vor Play
	#define RANDOMSONG		// Zufallswiedergabe verfgbar
	#define PLAYLIST		// [neu] Playlist-Untersttzung, erfordert KEY_REMAP
    //#define TEMPO_IN_BPM	// [neu] Aktuelles Tempo wird als bpm angezeigt und kann in 1er-Schritten gendert werden
	#define TRACK_DELAY		// [neu] Pause zwischen den Songs
	#define MANUAL_CALIBRATE// Kalibrierung des Oszillators im Men
	//#define CALIBRATE		// Automatische Kalibrierroutine
	#define REAL_TIME_DT	// [neu] Berechnung der Echtzeit ber den Deltatime-Interrupt
	
	//#define RC5_DISP		// Debug Displayanzeige
	
	#define BUFFERED_READ	// Gepuffertes Einlesen von Mididaten bei der Wiedergabe (erhht Timingsprzision)
	//#define BUFFERED_FILEENTRIES
	#define RC5				// IR-Remote-Untersttzung aktivieren
	//#define SD_TIMEOUT	// [neu] Erkennt schlechte SD-Karten
	//	#define SDTIMEOUT 100
	//#define MIDI_TX_BUF	// [neu] Gepufferte MIDI-Ausgabe ber Interrupt
	//#define OLD_CARDSCAN	// Raw-Scan der Karte, wenn kein FAT16 gefunden wurde
	//#define NOSECTORSEARCH	// Cluster werden nicht aus FAT allokiert (fragmentierte Karten nicht erlaubt)
	#define JAPAN_KANA

	#define OLD_BL			// Alter 1024-Word-Bootloader im Chip
	#define KEY_LR_SWITCHED	// Vertauschte Rechts&Links-Tasten

#elif defined(ULTIMATE_BIG)
	//#define BACKLIGHT		// LCD-Hintergrundbeleuchtung im Men einstellbar
    #define CHANNEL_MUTE	// MIDI-Kanalstummschaltfeature
    #define TRANSPOSE		// Transponierfeature
    #define LYRICS			// Lyricfeature
	#define MIDI_MONITOR	// MIDI-Monitor verfgbar
    //#define MIDI_BLIP		// [neu] Anzeige MIDI-Out-Aktivitt
    #define DIR_SUPPORT		// [neu] Untersttzung zum Browsen von Unterverzeichnissen
	#define LFN_SCROLLING	// [neu] Scrollt lange Dateinamen
		#define LFN_USEBUF	// Playbuf hernehmen
	#define KEY_REPEAT		// Taste gedrckt halten ist wie am PC
    #define KEY_REMAP		// [neu] Tastenbelegung neu
	#define DIREKTWAHL		// Wahl eines Songs per Zifferntasten
	#define USE_ALLCTRLOFF	// Sendet AllControllerOff-Nachricht vor Play
	#define RANDOMSONG		// Zufallswiedergabe verfgbar
	#define PLAYLIST		// [neu] Playlist-Untersttzung, erfordert KEY_REMAP
    //#define TEMPO_IN_BPM	// [neu] Aktuelles Tempo wird als bpm angezeigt und kann in 1er-Schritten gendert werden
	#define TRACK_DELAY		// [neu] Pause zwischen den Songs
	#define MANUAL_CALIBRATE// Kalibrierung des Oszillators im Men
	//#define CALIBRATE		// Automatische Kalibrierroutine
	#define REAL_TIME_DT	// [neu] Berechnung der Echtzeit ber den Deltatime-Interrupt
	
	//#define RC5_DISP		// Debug Displayanzeige
	
	#define BUFFERED_READ	// Gepuffertes Einlesen von Mididaten bei der Wiedergabe (erhht Timingsprzision)
	#define RC5				// IR-Remote-Untersttzung aktivieren
	//#define SD_TIMEOUT	// [neu] Erkennt schlechte SD-Karten
	//	#define SDTIMEOUT 100
	//#define MIDI_TX_BUF	// [neu] Gepufferte MIDI-Ausgabe ber Interrupt
	//#define OLD_CARDSCAN	// Raw-Scan der Karte, wenn kein FAT16 gefunden wurde
	//#define NOSECTORSEARCH	// Cluster werden nicht aus FAT allokiert (fragmentierte Karten nicht erlaubt)
	#define JAPAN_KANA

	#define NEW_BL			// Neuer 512-Word-Bootloader im Chip
	#define KEY_LR_SWITCHED	// Vertauschte Rechts&Links-Tasten

#elif defined(ULTIMATE_BIG_SPEEDCTRL)
	//#define BACKLIGHT		// LCD-Hintergrundbeleuchtung im Men einstellbar
    #define CHANNEL_MUTE	// MIDI-Kanalstummschaltfeature
    #define TRANSPOSE		// Transponierfeature
    #define LYRICS			// Lyricfeature
	//#define MIDI_MONITOR	// MIDI-Monitor verfgbar
    //#define MIDI_BLIP		// [neu] Anzeige MIDI-Out-Aktivitt
    #define DIR_SUPPORT		// [neu] Untersttzung zum Browsen von Unterverzeichnissen
	#define LFN_SCROLLING	// [neu] Scrollt lange Dateinamen
		#define LFN_USEBUF	// Playbuf hernehmen
	#define KEY_REPEAT		// Taste gedrckt halten ist wie am PC
    #define KEY_REMAP		// [neu] Tastenbelegung neu
	//#define DIREKTWAHL		// Wahl eines Songs per Zifferntasten
	#define USE_ALLCTRLOFF	// Sendet AllControllerOff-Nachricht vor Play
	#define RANDOMSONG		// Zufallswiedergabe verfgbar
	#define PLAYLIST		// [neu] Playlist-Untersttzung, erfordert KEY_REMAP
    //#define TEMPO_IN_BPM	// [neu] Aktuelles Tempo wird als bpm angezeigt und kann in 1er-Schritten gendert werden
	#define TRACK_DELAY		// [neu] Pause zwischen den Songs
	#define MANUAL_CALIBRATE// Kalibrierung des Oszillators im Men
	//#define CALIBRATE		// Automatische Kalibrierroutine
	#define REAL_TIME_DT	// [neu] Berechnung der Echtzeit ber den Deltatime-Interrupt
	
	//#define RC5_DISP		// Debug Displayanzeige
	
	#define BUFFERED_READ	// Gepuffertes Einlesen von Mididaten bei der Wiedergabe (erhht Timingsprzision)
	#define EXT_SPEEDSIG
	//#define RC5				// IR-Remote-Untersttzung aktivieren
	//#define SD_TIMEOUT	// [neu] Erkennt schlechte SD-Karten
	//	#define SDTIMEOUT 100
	//#define MIDI_TX_BUF	// [neu] Gepufferte MIDI-Ausgabe ber Interrupt
	//#define OLD_CARDSCAN	// Raw-Scan der Karte, wenn kein FAT16 gefunden wurde
	//#define NOSECTORSEARCH	// Cluster werden nicht aus FAT allokiert (fragmentierte Karten nicht erlaubt)
	#define JAPAN_KANA

	#define NEW_BL			// Neuer 512-Word-Bootloader im Chip
	#define KEY_LR_SWITCHED	// Vertauschte Rechts&Links-Tasten

#elif defined(NORMAL)
	#define BUFFERED_READ	// Gepuffertes Einlesen von Mididaten bei der Wiedergabe (erhht Timingsprzision)
	#define RC5				// IR-Remote-Untersttzung aktivieren
	
	#define BACKLIGHT		// LCD-Hintergrundbeleuchtung im Men einstellbar
    #define CHANNEL_MUTE    // MIDI-Kanalstummschaltfeature
    #define TRANSPOSE       // Transponierfeature
    #define LYRICS          // Lyricfeature
	//#define MIDI_MONITOR	// MIDI-Monitor verfgbar
	//#define KEY_REPEAT		// Taste gedrckt halten ist wie am PC
	#define DIREKTWAHL		// Wahl eines Songs per Zifferntasten
	#define RANDOMSONG		// Zufallswiedergabe verfgbar
	#define USE_ALLCTRLOFF	// Sendet AllControllerOff-Nachricht vor Play
	//#define MANUAL_CALIBRATE// Kalibrierung des Oszillators im Men
	//#define CALIBRATE		// Automatische Kalibrierroutine
	//#define SD_TIMEOUT		// [neu] Erkennt schlechte SD-Karten
		//#define SDTIMEOUT 100
	
	//#define RC5_DISP		// Debug Displayanzeige
	
	#define OLD_CARDSCAN	// Raw-Scan der Karte, wenn kein FAT16 gefunden wurde
	//#define NOSECTORSEARCH	// Cluster werden nicht aus FAT allokiert (fragmentierte Karten nicht erlaubt)

	#define OLD_BL			// Alter 1024-Word-Bootloader im Chip

#elif defined(PERFORMANT_PLAYER_DEBUG)
    #define BUFFERED_READ2  // [neu] Gepuffertes Einlesen von Mididaten bei der Wiedergabe (erhht max. Durchsatzrate)
    #define RC5             // IR-Remote-Untersttzung aktivieren
    
    #define DIR_SUPPORT     // [neu] Untersttzung zum Browsen von Unterverzeichnissen
    //#define NO_FILE_EXT     // [neu] Keine Dateierweiterung anzeigen
    #define NO_RECORD       // Alle Schreib- und Lschfunktionen weg
	#define NO_MENU			// Kein EEPROM und kein Men
    #define TEMPO_IN_BPM    // [neu] Aktuelles Tempo wird als bpm angezeigt und kann in 1er-Schritten gendert werden
    //#define KEY_REMAP       // [neu] Tastenbelegung neu
    //#define KEY_REPEAT      // Taste gedrckt halten ist wie am PC
	//#define MIDI_TX_BUF		// [neu] Gepufferte MIDI-Ausgabe ber Interrupt
	#define REAL_TIME_DT	// [neu] Berechnung der Echtzeit ber den Deltatime-Interrupt

	#define OLD_BL			// Alter 1024-Word-Bootloader im Chip

#elif defined(OLD_MEGA8)
	#define BUFFERED_READ 	// Gepuffertes Einlesen von Mididaten bei der Wiedergabe (erhht Timingsprzision)
	
	//#define BACKLIGHT		// LCD-Hintergrundbeleuchtung im Men einstellbar
    //#define CHANNEL_MUTE    // MIDI-Kanalstummschaltfeature
    #define TRANSPOSE       // Transponierfeature
    #define LYRICS          // Lyricfeature
	#define MIDI_MONITOR	// MIDI-Monitor verfgbar
    //#define MIDI_BLIP       // [neu] Anzeige MIDI-Out-Aktivitt
    #define DIR_SUPPORT     // [neu] Untersttzung zum Browsen von Unterverzeichnissen
	#define KEY_REPEAT		// Taste gedrckt halten ist wie am PC
    //#define TEMPO_IN_BPM    // [neu] Aktuelles Tempo wird als bpm angezeigt und kann in 1er-Schritten gendert werden
	//#define TRACK_DELAY		// [neu] Pause zwischen den Songs
    #define KEY_REMAP       // [neu] Tastenbelegung neu
	//#define MANUAL_CALIBRATE// Kalibrierung des Oszillators im Men
	//#define CALIBRATE		// Automatische Kalibrierroutine
	//#define SD_TIMEOUT		// [neu] Erkennt schlechte SD-Karten
	//	#define SDTIMEOUT 100
	//#define MIDI_TX_BUF		// [neu] Gepufferte MIDI-Ausgabe ber Interrupt
	#define REAL_TIME_DT	// [neu] Berechnung der Echtzeit ber den Deltatime-Interrupt
	//#define MIDI_TX_BUF		// [neu] Gepufferte MIDI-Ausgabe ber Interrupt
	
	//#define OLD_CARDSCAN	// Raw-Scan der Karte, wenn kein FAT16 gefunden wurde
	//#define NOSECTORSEARCH	// Cluster werden nicht aus FAT allokiert (fragmentierte Karten nicht erlaubt)
	//#define JAPAN_KANA
    #define NO_RECORD       // Alle Schreib- und Lschfunktionen weg

#elif defined(LED_DISP)
	//#define BUFFERED_READ2	// Gepuffertes Einlesen von Mididaten bei der Wiedergabe (erhht Timingsprzision)
    #define NO_RECORD       // Alle Schreib- und Lschfunktionen weg
	#define NO_MENU			// Kein EEPROM und kein Men

	#define OLD_BL			// Alter 1024-Word-Bootloader im Chip

#endif


#if defined(NEW_BL)
	#define SW_VERSION	(SW_VERSION_BASE | 0x80)
#else
	#define SW_VERSION	SW_VERSION_BASE
#endif


#endif

